---

stages:
  - lint
  - build
  - test
  - generate_release
  - release

variables:
  USE_CACHE: "false"
  IMAGE: "image"

include:
  - project: dreamer-labs/repoman/gitlab-ci-templates
    file: /.gitlab-ci-commitchecker.yml
    ref: master
  - project: dreamer-labs/repoman/gitlab-ci-templates
    file: /.gitlab-ci-lintdocs.yml
    ref: master
  - project: dreamer-labs/repoman/gitlab-ci-templates
    file: /.gitlab-ci-generate-release.yml
    ref: master
  - project: dreamer-labs/repoman/gitlab-ci-templates
    file: /.gitlab-ci-docker.yml
    ref: master

shellcheck:
  stage: lint
  image: "registry.gitlab.com/dreamer-labs/repoman/dl-buildit/image:latest"
  script:
    - shellcheck commitlintit
  except:
    variables:
      - $CI_COMMIT_MESSAGE =~ /^chore\(release\)/
  only:
    - merge_requests
    - master 

.int_test_template: &int_test_template
  stage: test
  image: ${CI_REGISTRY_IMAGE}/image:${DEVEL_SLUG}
  variables:
    DEVEL_SLUG: "devel"
    GIT_CLONE_PATH: "/builds/readonly"
  services:
    - docker:dind
  script:
    - run_test int $CI_JOB_NAME ./tests/int/$CI_JOB_NAME/cowabunga_conf.sh
  except:
    variables:
      - $CI_COMMIT_MESSAGE =~ /^chore\(release\)/
  only:
    - merge_requests
    - master

test_int_001:
  <<: *int_test_template

test_int_002:
  <<: *int_test_template

test_int_003:
  <<: *int_test_template

test_int_004:
  <<: *int_test_template

test_int_005:
  <<: *int_test_template

test_int_006:
  <<: *int_test_template

test_int_007:
  <<: *int_test_template

.fe_test_template: &fe_test_template
  stage: test
  image: ${CI_REGISTRY_IMAGE}/image:${DEVEL_SLUG}
  variables:
    DEVEL_SLUG: "devel"
    GIT_CLONE_PATH: "/builds/readonly"
  services:
    - docker:dind
  script:
    - run_test fe $CI_JOB_NAME
  except:
    variables:
      - $CI_COMMIT_MESSAGE =~ /^chore\(release\)/
  only:
    - merge_requests
    - master

test_fe_001:
  <<: *fe_test_template

test_fe_002:
  <<: *fe_test_template

...
